﻿Imports System.Data.OleDb
Imports C1.C1Report

Public Class Form1

    Dim rep_sel As String
    Dim strlist As String
    Dim strconn As String
    Dim da As OleDbDataAdapter
    Dim dt As DataTable
    Dim col_count As Integer
    Dim l As Double = 0
    Dim t As Double = 0
    Dim w As Double = 1500
    Dim h As Double = 300

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ListBox2.Items.Clear()
        Dim selectedItems = (From i In ListBox1.SelectedItems).ToArray()
        'Move the selected items in the ListBox2
        For Each selectedItem In selectedItems
            ListBox2.Items.Add(selectedItem)
        Next
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        C1Report1.DataSource.RecordSource = ""
        Dim field_count As Integer = C1Report1.Fields.Count
        For c = 0 To field_count - 1
            C1Report1.Fields.RemoveAt(c)
        Next
        Dim col As String = ""
        Dim items = (From i In ListBox2.Items).ToArray()

        'Get the list of all selected columns
        For i = 0 To ListBox2.Items.Count - 1
            If ListBox2.Items.Count > 1 Then
                If i < ListBox2.Items.Count - 1 Then
                    col = col & items(i).ToString & " , "
                Else
                    col = col & items(i).ToString
                End If
            Else
                col = items(i).ToString
            End If
        Next

        'Setting the recordsource on the basis of the selected column names
        C1Report1.DataSource.RecordSource = "select " & col & " from " & dt.TableName

        C1Report1.Layout.Orientation = OrientationEnum.Portrait

        Dim f As Field
        With C1Report1.Sections(SectionTypeEnum.Header)
            .Height = 1440
            .Visible = True
            .BackColor = Color.FromArgb(200, 200, 200)
            f = .Fields.Add("FldTitle", "New Report", 0, 0, 8000, 1440)
            f.Font.Size = 24
            f.Font.Bold = True
            f.ForeColor = Color.FromArgb(0, 0, 100)
        End With

        l = 0
        With C1Report1.Sections(SectionTypeEnum.PageHeader)
            .Height = 300
            .Visible = True
            .CanGrow = False
            C1Report1.Font.Bold = True

            For i As Integer = 0 To ListBox2.Items.Count - 1
                If i = 0 Then
                    f = .Fields.Add(ListBox2.Items(i).ToString, ListBox2.Items(i).ToString, 0, t, w, h)
                Else
                    l = l + 1500
                    f = .Fields.Add(ListBox2.Items(i).ToString, ListBox2.Items(i).ToString, l, t, w, h)
                End If
                f.Align = FieldAlignEnum.CenterMiddle
                f.CanGrow = True
            Next
        End With

        l = 0
        With C1Report1.Sections(SectionTypeEnum.Detail)
            .Height = 300
            .Visible = True
            .CanGrow = True
            C1Report1.Font.Bold = False


            For i As Integer = 0 To ListBox2.Items.Count - 1
                If i = 0 Then
                    f = .Fields.Add("D" & ListBox2.Items(i).ToString, ListBox2.Items(i).ToString, 0, t, w, h)
                Else
                    l = l + 1500
                    f = .Fields.Add("D" & ListBox2.Items(i).ToString, ListBox2.Items(i).ToString, l, t, w, h)
                End If
                f.Align = FieldAlignEnum.CenterMiddle
                f.Calculated = True
                f.CanGrow = True
            Next

        End With
        C1PrintPreviewControl1.Document = C1Report1
    End Sub

    Private Sub ComboBox1_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectionChangeCommitted
        C1Report1.Clear()
        ListBox1.Items.Clear()
        ListBox2.Items.Clear()
        rep_sel = ComboBox1.SelectedItem
        If rep_sel = "Report1" Then
            strlist = "select * from Products;"
            strconn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C1NWind.MDB;"
            da = New OleDbDataAdapter(strlist, strconn)
            dt = New DataTable("Products")
            dt.TableName = "Products"
            da.Fill(dt)
            col_count = dt.Columns.Count
            For i = 0 To col_count - 1
                ListBox1.Items.Add(dt.Columns(i).ColumnName)
            Next
            C1Report1.DataSource.ConnectionString = strconn

        ElseIf rep_sel = "Report2" Then
            strlist = "select * from Orders;"
            strconn = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C1NWind.MDB;"
            da = New OleDbDataAdapter(strlist, strconn)
            dt = New DataTable("Orders")
            dt.TableName = "Orders"
            da.Fill(dt)
            col_count = dt.Columns.Count
            For i = 0 To col_count - 1
                ListBox1.Items.Add(dt.Columns(i).ColumnName)
            Next
            C1Report1.DataSource.ConnectionString = strconn
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim selectedItems = (From i In ListBox2.SelectedItems).ToArray()
        Dim selectedItems1 = (From i In ListBox1.SelectedItems).ToArray()
        For Each selectedItem In selectedItems
            For Each selectedItem1 In selectedItems1
                If selectedItem1 = selectedItem Then
                    Dim i As Integer = ListBox1.Items.IndexOf(selectedItem1)
                    'Remove selection from the ListBox1
                    ListBox1.SetSelected(i, False)
                End If
            Next
            'Remove the selected items from the ListBox2
            ListBox2.Items.Remove(selectedItem)
        Next
    End Sub
End Class
